//http://homofaciens.de/technics-physical-computing-set01_en.htm

//Switching LEDs with IR remote

//Look at front of IR receiver (you can see the IR diode)
//Connect left pin of 1838 IR receiver to A0 of Arduino
//Connect middle pin of 1838 IR receiver GND of Arduino
//Connect right pin of 1838 IR receiver +5V of Arduino

//Connect kathode (- short pin, flat side of housing) of LED to GND of Arduino
//Connect anode (+ long pin, round side of housing) to 220 Ohm resistor
//Connect second end of 220 Ohm resistor to pin of Arduino

//LCD GND to Arduino GND
//LCD VCC to Arduino +5V
//LCD SDA to Arduino A4
//LCD SCL to Arduino A5

//Buzzer (+) to Arduino pin A3
//Buzzer (-) to Arduino GND

//Connect kathode (-) of motor board to GND of Arduino
//Connect anode (+) of motor board to +5V of Arduino
//Connect In1 of motor board to pin 2 of Arduino
//Connect In2 of motor board to pin 3 of Arduino
//Connect In3 of motor board to pin 4 of Arduino
//Connect In4 of motor board to pin 5 of Arduino

//Connect kathode (- brown or black servo cable) to GND of Arduino
//Connect anode (+ red servo cable) to +5V of Arduino
//Connect control line (orange or white cable) to pin A1 of Arduino

//Connect kathode (- short pin, flat side of housing) of LED to GND of Arduino
//Connect anode (+ long pin, round side of housing) to 220 Ohm resistor
//Connect second end of 220 Ohm resistor to pins 6 to 13 of Arduino


//Define pin number the LED is connected to
#define LED_IR_INDICATOR_PIN   A2
#define BUZZER_PIN             A3
#define IR_RECEIVER            A0
#define SERVO_01               A1
#define MOTOR_01                2
#define MOTOR_02                3
#define MOTOR_03                4
#define MOTOR_04                5
#define LED_01                 13
#define LED_02                 12
#define LED_03                 11
#define LED_04                 10
#define LED_05                  9
#define LED_06                  8
#define LED_07                  7
#define LED_08                  6

#define BOUNCE_TIME             0

#define SMALLGAP              120

#include <LiquidCrystal_I2C.h>
#include <Servo.h>

unsigned long pushPause = 999999;
unsigned long test0 = 0;
unsigned long test1 = 0;
unsigned long test2 = 0;
unsigned long test3 = 0;
unsigned long test4 = 0;
unsigned long test5 = 0;
unsigned long test6 = 0;
unsigned long test7 = 0;
unsigned long test8 = 0;

int oldButtonState = 0;
int newSequence = 0;
int done = 0;
int servoAngle = 0;

Servo servo_01;

LiquidCrystal_I2C lcd(0x27, 2, 1, 0, 4, 5, 6, 7, 3, POSITIVE);


void setup() {                 //This code is executed whenever the board is turned on or the reset button is pressed

  pinMode(LED_IR_INDICATOR_PIN, OUTPUT);
  pinMode(BUZZER_PIN, OUTPUT);
  pinMode(IR_RECEIVER, INPUT_PULLUP);
  pinMode(MOTOR_01, OUTPUT);
  pinMode(MOTOR_02, OUTPUT);
  pinMode(MOTOR_03, OUTPUT);
  pinMode(MOTOR_04, OUTPUT);
  pinMode(LED_01, OUTPUT);
  pinMode(LED_02, OUTPUT);
  pinMode(LED_03, OUTPUT);
  pinMode(LED_04, OUTPUT);
  pinMode(LED_05, OUTPUT);
  pinMode(LED_06, OUTPUT);
  pinMode(LED_07, OUTPUT);
  pinMode(LED_08, OUTPUT);
  servo_01.attach(SERVO_01);

  lcd.begin(16,2);               // initialize the lcd

  lcd.home ();                   // go home
  lcd.print("Physical        ");
  lcd.setCursor ( 0, 1 );        // go to the next line
  lcd.print("       Computing");
  delay (1000);


  pushPause = 999999;
  oldButtonState = 1;
  newSequence = 0;
  done = 0;
  test0 = 0;
  test1 = 0;
  test2 = 0;
  test3 = 0;
  test4 = 0;
  test5 = 0;
  test6 = 0;
  test7 = 0;
  test8 = 0;

  Serial.begin(115200);
//  while (!Serial) {
//    ; // wait for serial port to connect. Needed for native USB port only
//  }
}

void loop() {                       //This loop runs forever

  //Check push button state
  if(digitalRead(IR_RECEIVER)){
    digitalWrite(LED_IR_INDICATOR_PIN, LOW);
    oldButtonState = 1;
  }
  else{
    if(oldButtonState == 1){
      done = 2;
      digitalWrite(LED_IR_INDICATOR_PIN, HIGH);
      pushPause = millis();
      oldButtonState = 0;
      newSequence++;
    }
  }

  if(newSequence == 17){
    test0++;
  }
  if(newSequence == 18){
    test1++;
  }
  if(newSequence == 19){
    test2++;
  }
  if(newSequence == 20){
    test3++;
  }
  if(newSequence == 21){
    test4++;
  }
  if(newSequence == 22){
    test5++;
  }
  if(newSequence == 23){
    test6++;
  }
  if(newSequence == 24){
    test7++;
  }
  if(newSequence == 25){
    test8++;
  }

  //Change sequence if nothing happened for 100ms = 0.1s
  if(millis() - pushPause > 100 && done == 2){
    done = 0;
  }


  if(done == 0){
    newSequence = 0;
    if(test0 > SMALLGAP){
      test0 = 1;
      newSequence += 1;
    }
    else{
      test0 = 0;
    }

    if(test1 > SMALLGAP){
      test1 = 1;
    }
    else{
      test1 = 0;
    }

    if(test2 > SMALLGAP){
      test2 = 1;
      newSequence += 2;
    }
    else{
      test2 = 0;
    }

    if(test3 > SMALLGAP){
      test3 = 1;
      newSequence += 4;
    }
    else{
      test3 = 0;
    }

    if(test4 > SMALLGAP){
      test4 = 1;
      newSequence += 8;
    }
    else{
      test4 = 0;
    }

    if(test5 > SMALLGAP){
      test5 = 1;
      newSequence += 16;
    }
    else{
      test5 = 0;
    }

    if(test6 > SMALLGAP){
      test6 = 1;
      newSequence += 32;
    }
    else{
      test6 = 0;
    }

    if(test7 > SMALLGAP){
      test7 = 1;
      newSequence += 64;
    }
    else{
      test7 = 0;
    }

    if(test8 > SMALLGAP){
      test8 = 1;
      newSequence += 128;
    }
    else{
      test8 = 0;
    }

    Serial.print(test0);
    Serial.print(", ");
    Serial.print(test1);
    Serial.print(", ");
    Serial.print(test2);
    Serial.print(", ");
    Serial.print(test3);
    Serial.print(", ");
    Serial.print(test4);
    Serial.print(", ");
    Serial.print(test5);
    Serial.print(", ");
    Serial.print(test6);
    Serial.print(", ");
    Serial.print(test7);
    Serial.print(", ");
    Serial.print(test8);
    Serial.print(", ");
    Serial.print(newSequence);
    Serial.println(" ");

    test0 = 0;
    test1 = 0;
    test2 = 0;
    test3 = 0;
    test4 = 0;
    test5 = 0;
    test6 = 0;
    test7 = 0;
    test8 = 0;


    //Switch LEDs according to latest push button sequence
    if(newSequence == 23){
      lcd.setCursor ( 0, 0 );        // go to the next line
      lcd.print("Received code 23");
      lcd.setCursor ( 0, 1 );        // go to the next line
      lcd.print("Beeping...      ");
      for(int i = 0; i < 3; i++){
        digitalWrite(BUZZER_PIN, HIGH);
        delay(100);
        digitalWrite(BUZZER_PIN, LOW);
        delay(100);
      }
    }
    if(newSequence == 13){
      lcd.setCursor ( 0, 0 );        // go to the next line
      lcd.print("Received code 13");
      lcd.setCursor ( 0, 1 );        // go to the next line
      lcd.print("Adjusting servo ");
      servoAngle += 40;
      if(servoAngle > 180){
        servoAngle = 0;
      }
      servo_01.write(servoAngle);
    }

    if(newSequence == 25){
      lcd.setCursor ( 0, 0 );        // go to the next line
      lcd.print("Received code 25");
      lcd.setCursor ( 0, 1 );        // go to the next line
      lcd.print("Turning motor...");
      for(int i = 0; i < 400; i++){
        digitalWrite(MOTOR_01, HIGH);
        digitalWrite(MOTOR_04, LOW);
        delay(3);
        digitalWrite(MOTOR_02, HIGH);
        digitalWrite(MOTOR_01, LOW);
        delay(3);
        digitalWrite(MOTOR_03, HIGH);
        digitalWrite(MOTOR_02, LOW);
        delay(3);
        digitalWrite(MOTOR_04, HIGH);
        digitalWrite(MOTOR_03, LOW);
        delay(3);
      }
    }

    if(newSequence == 95){
      lcd.setCursor ( 0, 0 );        // go to the next line
      lcd.print("Received code 95");
      lcd.setCursor ( 0, 1 );        // go to the next line
      lcd.print("Switching LEDs  ");
      for(int i = 0; i < 2; i++){
        digitalWrite(LED_01, HIGH);
        delay(200);
        digitalWrite(LED_01, LOW);
        digitalWrite(LED_02, HIGH);
        delay(200);
        digitalWrite(LED_02, LOW);
        digitalWrite(LED_03, HIGH);
        delay(200);
        digitalWrite(LED_03, LOW);
        digitalWrite(LED_04, HIGH);
        delay(200);
        digitalWrite(LED_04, LOW);
        digitalWrite(LED_05, HIGH);
        delay(200);
        digitalWrite(LED_05, LOW);
        digitalWrite(LED_06, HIGH);
        delay(200);
        digitalWrite(LED_06, LOW);
        digitalWrite(LED_07, HIGH);
        delay(200);
        digitalWrite(LED_07, LOW);
        digitalWrite(LED_08, HIGH);
        delay(200);
        digitalWrite(LED_08, LOW);
      }
    }

    lcd.setCursor ( 0, 0 );        // go to the next line
    lcd.print("Physical        ");
    lcd.setCursor ( 0, 1 );        // go to the next line
    lcd.print("       Computing");

    newSequence = 0;
    done = 1;
  }//if(done == 0)


}
