//http://homofaciens.de/technics-physical-computing-set01_en.htm

//Controlling a servo and a stepper motor through a mini joystick

//Connect kathode (-) of motor board to GND of Arduino
//Connect anode (+) of motor board to +5V of Arduino
//Connect In1 of motor board to pin 8 of Arduino
//Connect In2 of motor board to pin 9 of Arduino
//Connect In3 of motor board to pin 10 of Arduino
//Connect In4 of motor board to pin 11 of Arduino


//Connect kathode (- brown or black servo cable) to GND of Arduino
//Connect anode (+ red servo cable) to +5V of Arduino
//Connect control line (orange or white cable) to pin 2 of Arduino

//Joystick GND to Arduino GND
//Joystick +5V to Arduino +5V
//Joystick VRx to Arduino A0
//Joystick VRy to Arduino A1
//Joystick SW to Arduino A2


#include <Servo.h>

#define POTI_PIN_1    A0
#define POTI_PIN_2    A1
#define PUSH_BUTTON   A2
#define SERVO_PIN_01   2
#define MOTOR_PIN_01   8
#define MOTOR_PIN_02   9
#define MOTOR_PIN_03  10
#define MOTOR_PIN_04  11

int servoDirection = 0;
int buttonState = 0;
int motorPause = 100;
int motorStep = 0;

Servo servo01;

int ADCval1;    // variable to read the value from the analog pin
int ADCval2;    // variable to read the value from the analog pin

void setup() {
  servo01.attach(SERVO_PIN_01);  // attaches the servo on pin 9 to the servo object
  pinMode(PUSH_BUTTON, INPUT_PULLUP);
  pinMode(POTI_PIN_1, INPUT);
  pinMode(POTI_PIN_2, INPUT);

  pinMode(MOTOR_PIN_01, OUTPUT);
  pinMode(MOTOR_PIN_02, OUTPUT);
  pinMode(MOTOR_PIN_03, OUTPUT);
  pinMode(MOTOR_PIN_04, OUTPUT);

  servoDirection = 0;
  buttonState = 1;

  pinMode(13, OUTPUT);

  motorPause = 5;
  motorStep = 0;

  Serial.begin(115200);

}

void loop() {
  if(digitalRead(PUSH_BUTTON)){
    digitalWrite(13, HIGH);
    if(buttonState == 0){
      buttonState = 1;
      delay(500);//Wait for contact bounce to finish
    }
  }
  else{
    digitalWrite(13, LOW);
    if(buttonState == 1){
      buttonState = 0;
      if(servoDirection == 0){
        servoDirection = 1;
      }
      else{
        servoDirection = 0;
      }
      delay(500);//Wait for contact bounce to finish
    }
  }
  ADCval1 = analogRead(POTI_PIN_1);           // reads the value of the potentiometer (value between 0 and 1023)
  ADCval1 = map(ADCval1, 0, 1023, 0, 180);   // scale it to use it with the servo (value between 0 and 180)
  if(servoDirection == 1){
    ADCval1 = 180 - ADCval1;
  }
  servo01.write(ADCval1);

  ADCval2 = analogRead(POTI_PIN_2);           // reads the value of the potentiometer (value between 0 and 1023)
  ADCval2 = map(ADCval2, 0, 1023, -6, 6);   // scale it to use it with the servo (value between 0 and 180)

  //ADCval2 = ADCval2 - 6;


  if(servoDirection == 1){
    ADCval2 = -ADCval2;
  }
  motorPause = abs(ADCval2);


  if(motorPause > 0){
    motorPause = 8 - motorPause;
  }

  Serial.println(motorPause);


  if(motorPause != 0 && motorPause < 7){
    if(ADCval2 > 0){
      motorStep++;
    }
    else{
      motorStep--;
    }
    if(motorStep == 4){
      motorStep = 0;
    }
    if(motorStep == -1){
      motorStep = 3;
    }
  }
  if(motorStep == 0){
    digitalWrite(MOTOR_PIN_01, HIGH);
    digitalWrite(MOTOR_PIN_02, LOW);
    digitalWrite(MOTOR_PIN_03, LOW);
    digitalWrite(MOTOR_PIN_04, LOW);
  }
  if(motorStep == 1){
    digitalWrite(MOTOR_PIN_01, LOW);
    digitalWrite(MOTOR_PIN_02, LOW);
    digitalWrite(MOTOR_PIN_03, HIGH);
    digitalWrite(MOTOR_PIN_04, LOW);
  }
  if(motorStep == 2){
    digitalWrite(MOTOR_PIN_01, LOW);
    digitalWrite(MOTOR_PIN_02, HIGH);
    digitalWrite(MOTOR_PIN_03, LOW);
    digitalWrite(MOTOR_PIN_04, LOW);
  }
  if(motorStep == 3){
    digitalWrite(MOTOR_PIN_01, LOW);
    digitalWrite(MOTOR_PIN_02, LOW);
    digitalWrite(MOTOR_PIN_03, LOW);
    digitalWrite(MOTOR_PIN_04, HIGH);
  }
  delay(motorPause);
}

