//http://homofaciens.de/technics-physical-computing-set01_en.htm

//Blinking multiple LEDs

//Connect kathode (- short pin, flat side of housing) of LED to GND of Arduino
//Connect anode (+ long pin, round side of housing) to 220 Ohm resistor
//Connect second end of 220 Ohm resistor to pin 2 - 13 of Arduino


//Define pin number the LED is connected to
#define LED_R_01_PIN  2
#define LED_R_02_PIN  3
#define LED_R_03_PIN  4
#define LED_R_04_PIN  5

#define LED_Y_01_PIN  6
#define LED_Y_02_PIN  7
#define LED_Y_03_PIN  8
#define LED_Y_04_PIN  9

#define LED_B_01_PIN 10
#define LED_B_02_PIN 11
#define LED_B_03_PIN 12
#define LED_B_04_PIN 13

int i;
int j;

void setup() {                 //This code is executed whenever the board is turned on or the reset button is pressed
  //Switch all LED pins to output mode
  pinMode(LED_R_01_PIN, OUTPUT);
  pinMode(LED_R_02_PIN, OUTPUT);
  pinMode(LED_R_03_PIN, OUTPUT);
  pinMode(LED_R_04_PIN, OUTPUT);

  pinMode(LED_Y_01_PIN, OUTPUT);
  pinMode(LED_Y_02_PIN, OUTPUT);
  pinMode(LED_Y_03_PIN, OUTPUT);
  pinMode(LED_Y_04_PIN, OUTPUT);

  pinMode(LED_B_01_PIN, OUTPUT);
  pinMode(LED_B_02_PIN, OUTPUT);
  pinMode(LED_B_03_PIN, OUTPUT);
  pinMode(LED_B_04_PIN, OUTPUT);
}

void loop() {                       //This loop runs forever

  //Turn all LEDs ON in sequence
  for(i=2; i<14; i++){
    //Turn pin on
    digitalWrite(i, HIGH);
    delay(100);
  }
  //Turn all LEDs OFF in sequence
  for(i=2; i<14; i++){
    //Turn pin off
    digitalWrite(i, LOW);
    delay(100);
  }

  //Running light red to blue
  digitalWrite(2, HIGH);
  delay(100);
  for(i=3; i<14; i++){
    digitalWrite(i, HIGH);
    digitalWrite(i-1, LOW);
    delay(100);
  }

  //Running light blue to red
  for(i=12; i>1; i--){
    digitalWrite(i, HIGH);
    digitalWrite(i+1, LOW);
    delay(100);
  }

  digitalWrite(2, LOW);

  delay(100);                      // wait 1000 milliseconds = 1 second

  for(i=0; i<256; i++){
    analogWrite(3, i);
    analogWrite(5, i);
    delay(10);
  }
  for(j=0; j<3; j++){
    for(i=255; i>=0; i--){
      analogWrite(3, i);
      analogWrite(5, i);
      analogWrite(6, 255 - i);
      analogWrite(9, 255 - i);
      delay(10);
    }
    for(i=255; i>=0; i--){
      analogWrite(6, i);
      analogWrite(9, i);
      analogWrite(10, 255 - i);
      analogWrite(11, 255 - i);
      delay(10);
    }
    for(i=255; i>=0; i--){
      analogWrite(10, i);
      analogWrite(11, i);
      analogWrite(3, 255 - i);
      analogWrite(5, 255 - i);
      delay(10);
    }
  }
  for(i=255; i>=0; i--){
    analogWrite(3, i);
    analogWrite(5, i);
    delay(10);
  }



}
